<?php
/*
 * Copyright (c) 2017-2022 Aimy Extensions, Netzum Sorglos Software GmbH
 * Copyright (c) 2014-2017 Aimy Extensions, Lingua-Systems Software GmbH
 *
 * https://www.aimy-extensions.com/
 *
 * License: GNU GPLv2, see LICENSE.txt within distribution and/or
 *          https://www.aimy-extensions.com/software-license.html
 */
 defined( '_JEXEC' ) or die(); require_once( JPATH_ADMINISTRATOR . '/components/com_aimysitemap/HttpClient.php' ); require_once( JPATH_ADMINISTRATOR . '/components/com_aimysitemap/Uri.php' ); require_once( JPATH_ADMINISTRATOR . '/components/com_aimysitemap/helpers/config.php' ); abstract class AimySitemapNotifier { static private $google_url = 'http://www.google.com/webmasters/sitemaps/ping?sitemap=%s'; static public function is_enabled( $se ) { $cfg = new AimySitemapConfigHelper(); return $cfg->get( 'notify_' . strtolower( $se ), false ); } static public function ping_all_enabled() { $rv = true; if ( self::is_enabled( 'google' ) ) { if ( ! self::ping_google() ) { $rv = false; } } if ( self::is_enabled( 'indexnow' ) ) { if ( ! self::ping_indexnow() ) { $rv = false; } } return $rv; } static public function ping( $se ) { $m = 'ping_' . strtolower( $se ); if ( method_exists( __CLASS__, $m ) ) { return self::$m(); } return false; } static public function ping_google() { $cfg = new AimySitemapConfigHelper(); $sm_path = $cfg->get( 'xml_path', '/sitemap.xml' ); $sm_url = JUri::root() . $sm_path; $req_url = sprintf( self::$google_url, urlencode( $sm_url ) ); $u = new AimySitemapUri( $req_url ); $resp = null; AimySitemapHttpClient::set_ua_name( 'AimySitemapNotifier/31.0' ); $resp = AimySitemapHttpClient::get_url( $u ); if ( is_array( $resp ) && isset( $resp[ 'head' ] ) && $resp[ 'head' ][ 'code' ] == '200' ) { AimySitemapLogger::debug( "Notifier: Sending ping to Google: OK" ); return array( 'ok' => true ); } AimySitemapLogger::debug( "Notifier: Sending ping to Google: FAILED ($req_url)" ); return false; } static public function ping_indexnow() { require_once( __DIR__ . '/IndexNow.php' ); $count = 0; try { $count = AimySitemapIndexNow::submit_recent_changes(); } catch ( Exception $e ) { AimySitemapLogger::error( $e->getMessage() ); return false; } $res = array( 'ok' => true ); if ( $count == 0 ) { $res[ 'msg' ] = JText::_( 'AIMY_SM_MSG_INDEXNOW_NO_RECENT_CHANGES' ); } else { $res[ 'msg' ] = JText::sprintf( 'AIMY_SM_MSG_INDEXNOW_NOTIFIED_X', $count ); } return $res; } } 
